
-- get plan and other caches for extended events
select p.name + '.' + o.name as [Full Name], 
       o.description 
from sys.dm_xe_objects o
join sys.dm_xe_packages p on o.package_guid = p.guid
where o.object_type = 'event' 
and o.description like '%plan%' or o.description like '%cache%'
order by p.name, o.name

select p.name + '.' + o.name as [Full Name], 
       o.description
from sys.dm_xe_objects o
join sys.dm_xe_packages p on o.package_guid = p.guid
where o.object_type = 'action' and o.name like '%plan%'
order by p.name, o.name

-- compare with perfmon counters, no direct name correlation
select distinct object_name, counter_name 
from sys.dm_os_performance_counters c
where counter_name like '%plan%' or counter_name like '%cache%'
order by object_name, counter_name

-- related trace events
select * from sys.trace_events
where name like '%plan%' or name like '%cache%'

-- see related views below
select * from sys.trace_categories
select * from sys.trace_subclass_values
